//+------------------------------------------------------------------+
//|                                              clon_fxclon_v,2.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Jeka"
#property link      ""

#include <stderror.mqh>
#include <stdlib.mqh>

extern double StartLot       = 0.1;
extern int    TakeProfit     = 50;
//extern int    StopLoss       = 100;
extern int slipage = 5;
extern int    MN_Buy         = 12345;      //   (      )
extern int    MN_Sell        = 54321;      //   (      )
extern bool   Debug          = False;

double LastTickTime;
double BuyPrice, BuyLots, BuyTP, BuySL, SellPrice, SellTP, SellSL, SellLots;
double BuyStopPrice, BuyStopTP, BuyStopSL, SellStopPrice, SellStopTP, SellStopSL;
int FirstBuyTicket, FirstSellTicket, BuyStopTicket, SellStopTicket, Step, Error;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  int TotalOrders;
  double NewPrice, NewLots, NewTP, NewSL;
  /*****************************************************************************/
  /*   ,                        */ 
  /*****************************************************************************/
  TotalOrders = CountOfOrders(); 
     double sprd = Ask-Bid;
     int tot = CountOfOrders2();
     double spred = spred/Point*(tot-1);
  if(tot > 1)PercCloseDown();
  /*****************************************************************************/
  /*   ,              */ 
  /*****************************************************************************/
  if(TotalOrders == 0)
  {
    LastTickTime = MarketInfo(Symbol(), MODE_TIME);
    FirstBuyTicket = SendMarketOrder(OP_BUY, StartLot, TakeProfit, TakeProfit*2, MN_Buy, "", Error);
    FirstSellTicket = SendMarketOrder(OP_SELL, StartLot, TakeProfit, TakeProfit*2, MN_Sell, "", Error);
    if(OrderSelect(FirstBuyTicket, SELECT_BY_TICKET))
    {
      BuyPrice = OrderOpenPrice();
      //BuyLots = OrderLots();
      BuyTP = OrderTakeProfit()+sprd;
      BuySL = OrderStopLoss();
    }
    if(OrderSelect(FirstSellTicket, SELECT_BY_TICKET))
    {
      SellPrice = OrderOpenPrice();
      //SellLots = OrderLots();
      SellTP = OrderTakeProfit()-sprd;
      SellSL = OrderStopLoss();
    }
    BuyStopTicket = SendPendingOrder(OP_BUYSTOP, BuyTP, StartLot*2 , 0, 0, MN_Buy, "", Error);
    SellStopTicket = SendPendingOrder(OP_SELLSTOP, SellTP, StartLot*2 , 0, 0, MN_Sell, "", Error);
    Step = 0;
    return(0);
  }

  /****************************************************************************************/
  /*   ,            */ 
  /****************************************************************************************/
  if(TotalOrders > 0)
  {
  
    if(!MarketOrdersExists())
    {
      DeleteAllPendingOrders(Error);
      return(0);
    }
    if(Step == 0)
    { 
      if(BuyEvent(FirstBuyTicket, BuyStopTicket, Error))
      {
        BuyStopPrice = BuyTP;
        BuyStopTP = SellSL;
        BuyStopSL = SellTP;
        SellStopPrice = BuyPrice;
        SellStopTP = SellTP;
        SellStopSL = SellSL;
        if(DeletePendingOrder(SellStopTicket, Error))
        {
          NewPrice = SellStopPrice; 
          NewLots  = GetBuyOrdersLots() * 2 - GetSellOrdersLots();
          NewTP = SellStopTP; 
          NewSL = SellStopSL; 
          SellStopTicket = SendPendingOrder(OP_SELLSTOP, NewPrice, NewLots, 0,NewSL, MN_Sell, "", Error);
          ModifyOrderAll( SellStopTicket);
          Step = 1;
        }
        else
          Print("     #", SellStopTicket);
        return(0);
      }
      if(SellEvent(FirstSellTicket, SellStopTicket, Error))
      {
        BuyStopPrice = SellPrice;
        BuyStopTP = BuyTP;
        BuyStopSL = BuySL;
        SellStopPrice = SellTP;
        SellStopTP = BuySL;
        SellStopSL = BuyTP;
        if(DeletePendingOrder(BuyStopTicket, Error))
        {
          NewPrice = BuyStopPrice; 
          NewLots  = GetSellOrdersLots() * 2 - GetBuyOrdersLots();
          NewTP = BuyStopTP;
          NewSL = BuyStopSL;
          BuyStopTicket = SendPendingOrder(OP_BUYSTOP, NewPrice, NewLots, 0, NewSL, MN_Buy, "", Error);
          ModifyOrderAll( BuyStopTicket); 
          Step = 2;
        }
        else
          Print("     #", SellStopTicket);
        return(0);
      }
    }
    if(Step == 2) 
    { 
      //     2- :
      //1.     BUY.
      if(POBuyEvent(BuyStopTicket))
      { //    BUY -  SELLSTOP-.
        //Print("Step == 2 && POBuyEvent(BuyStopTicket)");
        NewPrice = SellStopPrice; 
        NewLots  = GetBuyOrdersLots() * 2 - GetSellOrdersLots();
        NewTP = SellStopTP;//SellStopTP-spred; 
        NewSL = SellStopSL;//SellStopSL+spred; 
        SellStopTicket = SendPendingOrder(OP_SELLSTOP, NewPrice, NewLots, 0,NewSL, MN_Sell, "", Error);
        ModifyOrderAll( SellStopTicket);
        Step = 1; //    1.
        return(0);
      }
      //2.  MarketBuy-     MarketSell-  .
      if(MarketDownEvent(Error))
      {
        return(0);
      }
    }
    if(Step == 1)
    { //     2- :
      //1.     Sell.
      if(POSellEvent(SellStopTicket))
      { //   -  BUYSTOP-.
        //Print("Step == 1 && POSellEvent(SellStopTicket)");
        NewPrice = BuyStopPrice; 
        NewLots  = GetSellOrdersLots() * 2 - GetBuyOrdersLots();
        NewTP = BuyStopTP;//BuyStopTP+spred; 
        NewSL = BuyStopSL;//BuyStopSL-spred; 
        BuyStopTicket = SendPendingOrder(OP_BUYSTOP, NewPrice, NewLots, 0,NewSL, MN_Buy, "", Error);
        ModifyOrderAll( BuyStopTicket);
        Step = 2; //    2.
        return(0);
      }
      //2.  MarketSell-     MarketBuy-  .
      if(MarketUpEvent(Error))
      {
        return(0);
      }
    }
  }
  return(0);
}
//+------------------------------------------------------------------+

int PercCloseDown()
   {
      double Pr11 = 0; 
      int oti = 2147483647;
      int tot = CountOfOrders2();
      for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
      {
        if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
          if (OrderSymbol() == Symbol())
           {
             if((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell))
             {
             Pr11 = Pr11 + OrderProfit()+OrderCommission()+OrderSwap();
             }
           }
      }
      if(Pr11>StartLot*(tot+slipage)*10)
      {
       ClAll();
       DeleteAllPendingOrders(Error);
      }
return(0);
 }
//--------------------------------------
bool ClAll()
{
for(int i=OrdersTotal();i>=0;i--)
   { OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
       if(OrderSymbol( )==Symbol())      //      
         { 
          if((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell))     //   
            {
             if( OrderType( ) == 1 ) //   
                   {while(!OrderClose( OrderTicket(), OrderLots(), NormalizeDouble(Ask,Digits),slipage, Red))
                    {Sleep(1000);RefreshRates();}
                   } 
                   
                    if( OrderType( ) == 0 ) //   
                   {while(!OrderClose( OrderTicket(), OrderLots(), NormalizeDouble(Bid,Digits),slipage, Red))
                    {Sleep(1000);RefreshRates();}
                   } 
             }
         }
    } 
}
//---------------------------------------------------------
//+------------------------------------------------------------------+
//| SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Err)
//+------------------------------------------------------------------+
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Err)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Error; 
  bool Delay = False;
  if(Debug) Print(" SendMarketOrder");

  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Err = ERR_TRADE_DISABLED;
      Print("  !  \"\" .");
      return(-1);
    }
    if(Debug) Print("  ");
    if(!IsConnected())
    {
      Err = ERR_NO_CONNECTION;
      Print(" !");
      return(-1);
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    if(Delay || MarketInfo(Symbol(), MODE_TIME) != LastTickTime) 
    {
      if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(), MODE_TIME);
      Delay = False;
    }
    else
    {
      if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Ask + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Ask - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Bid - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Bid + SL * Point, Digits));
        Color = Red;
        break;
      default:
        if(Debug) Print("    .");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(!IsTradeAllowed())
    {
      if(Debug) Print("  !     .");
      return(-1);
    }
    else
    {
      if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Error = GetLastError();
        if (Error == 4   || // SERVER_BUSY 
            Error == 129 || // INVALID_PRICE 
            Error == 135 || // PRICE_CHANGED 
            Error == 137 || // BROKER_BUSY 
            Error == 138 || // REQUOTE 
            Error == 146 || // TRADE_CONTEXT_BUSY 
            Error == 136 )  // OFF_QUOTES 
        {
          if(Debug) Print("(OrderSend - ", Error, "): ", ErrorDescription(Error));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderSend - ", Error, "): ", ErrorDescription(Error));
          //Ticket = -1;
          Err = Error;
          break;
        }
      }
      break;
    }
  }
  
  if(Debug)
    if(Ticket > 0)
      Print("  .  = ",Ticket);
    else
      Print("!   . (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| IIFd(bool condition, double ifTrue, double ifFalse)              |
//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| SendPendingOrder(int Type, double Price, double Lots, int TP, int SL, int Magic, string Cmnt, int& Err)
//+------------------------------------------------------------------+
int SendPendingOrder(int Type, double InPrice, double Lots, double TPPrice, double SLPrice, int Magic, string Cmnt, int& Err)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Error; 
  //bool Delay = False;
  if(Debug) Print(" SendMarketOrder");
  //if(Debug) Print(" :");
  //if(Debug) Print("Lots = ", Lots,"; InPrice = ", InPrice,"; SLPrice = ", SLPrice, "; TPPrice = ", TPPrice);

  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Err = ERR_TRADE_DISABLED;
      Print("  !  \"\" .");
      return(-1);
    }
    if(Debug) Print("  ");
    if(!IsConnected())
    {
      Err = ERR_NO_CONNECTION;
      Print(" !");
      return(-1);
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      //Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    switch(Type)
    {
      case OP_BUYSTOP:
        if(Debug) Print("   BUYSTOP-");
        Price = NormalizeDouble( InPrice, Digits);
        Take = IIFd(TPPrice == 0, 0, NormalizeDouble( TPPrice, Digits));
        Stop = IIFd(SLPrice == 0, 0, NormalizeDouble( SLPrice, Digits));
        Color = Blue;
        break;
      case OP_SELLSTOP:
        if(Debug) Print("   SELLSTOP-");
        Price = NormalizeDouble( InPrice, Digits);
        Take = IIFd(TPPrice == 0, 0, NormalizeDouble( TPPrice, Digits));
        Stop = IIFd(SLPrice == 0, 0, NormalizeDouble( SLPrice, Digits));
        Color = Red;
        break;
      default:
        if(Debug) Print("    .");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(!IsTradeAllowed())
    {
      if(Debug) Print("  !     .");
      return(-1);
    }
    else
    {
      if(Debug) Print(" ,  ...");
      //if(Debug) Print("Lots = ", Lots,"; Price = ", Price,"; Stop = ", Stop, "; Take = ", Take);
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Error = GetLastError();
        if (Error == 4   || // SERVER_BUSY 
            //Error == 129 || // INVALID_PRICE 
            //Error == 135 || // PRICE_CHANGED 
            Error == 137 || // BROKER_BUSY 
            //Error == 138 || // REQUOTE 
            Error == 146 || // TRADE_CONTEXT_BUSY 
            Error == 136 )  // OFF_QUOTES 
        {
          if(Debug) Print("(OrderSend - ", Error, "): ", ErrorDescription(Error));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          //Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderSend - ", Error, "): ", ErrorDescription(Error));
          //Ticket = -1;
          Err = Error;
          break;
        }
      }
      break;
    }
  }
  
  if(Debug)
    if(Ticket > 0)
      Print("  .  = ",Ticket);
    else
      Print("!   . (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| CountOfOrders()                                                  |
//+------------------------------------------------------------------+
int CountOfOrders()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy || OrderMagicNumber() == MN_Sell)
          if(OrderType() == OP_BUY || OrderType() == OP_SELL || OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) 
            count++;
  return(count);
}
//+------------------------------------------------------------------+
int CountOfOrders2()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy || OrderMagicNumber() == MN_Sell)
          if(OrderType() == OP_BUY || OrderType() == OP_SELL) 
            count++;
  return(count);
}
//+------------------------------------------------------------------+


bool DeletePendingOrder(int Ticket, int& Err)
{
  int Error;
  bool Result = False;
  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    if(DeleteOrder(Ticket, Error))  //    OrderDelete(Ticket, CLR_NONE);
    {  
      Err = ERR_NO_ERROR;
      Result = True;
    }
    else
      Err = Error; 
  return(Result);
}
//+------------------------------------------------------------------+

bool IsOrderClosed(int Ticket)
{
  bool Result=False;
  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    if(OrderCloseTime() > 0)
      Result = True;
  return(Result);
}
//+------------------------------------------------------------------+

bool BuyEvent(int FB_Ticket, int BS_Ticket, int& Err)
{
  int Error;
  bool Result = False;
  bool PendingEvent = POBuyEvent(BS_Ticket);
  bool MarketEvent = IsOrderClosed(FB_Ticket);
  if(PendingEvent && MarketEvent)
  {
    Err = ERR_NO_ERROR;
    Result = True;
  }
  if(PendingEvent && !MarketEvent)
    if(CloseMarketOrder(FB_Ticket, Error))
    {
      Err = ERR_NO_ERROR;
      Result = True;
    }
    else
      Err = Error;
  /*
  if(!PendingEvent && MarketEvent)
    if(!CloseMarketOrder(FirstBuyTicket, Error))
    {
      return(0);
    }
  */
  return(Result);
}
//+------------------------------------------------------------------+

bool POBuyEvent(int Ticket)
{
  bool Result=False;
  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    if(OrderType()== OP_BUY)
      Result = True;
  return(Result);
}
//+------------------------------------------------------------------+

bool SellEvent(int FS_Ticket, int SS_Ticket, int& Err)
{
  int Error;
  bool Result = False;
  bool PendingEvent = POSellEvent(SS_Ticket);
  bool MarketEvent = IsOrderClosed(FS_Ticket);
  if(PendingEvent && MarketEvent)
  {
    Err = ERR_NO_ERROR;
    Result = True;
  }
  if(PendingEvent && !MarketEvent)
    if(CloseMarketOrder(FS_Ticket, Error))
    {
      Err = ERR_NO_ERROR;
      Result = True;
    }
    else
      Err = Error;
  return(Result);
}
//+------------------------------------------------------------------+

bool POSellEvent(int Ticket)
{
  bool Result=False;
  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    if(OrderType()== OP_SELL)
      Result = True;
  return(Result);
}
//+------------------------------------------------------------------+
/*
double GetSellOrderPrice()
{
  double Result = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
        if(OrderType()== OP_SELL) 
          Result = OrderOpenPrice();
  return(Result);
}
//+------------------------------------------------------------------+

double GetBuyOrderPrice()
{
  double Result = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
        if(OrderType()== OP_BUY) 
          Result = OrderOpenPrice();
  return(Result);
}
*///+------------------------------------------------------------------+

double GetBuyOrdersLots()
{
  double Result = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
        if(OrderType()== OP_BUY)
          Result = Result + OrderLots();
  return(Result);
}
//+------------------------------------------------------------------+

double GetSellOrdersLots()
{
  double Result = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
        if(OrderType()== OP_SELL) 
          Result = Result + OrderLots();
  return(Result);
}
//+------------------------------------------------------------------+

bool MarketOrdersExists()
{
  bool Result=False;
  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy || OrderMagicNumber() == MN_Sell)
          if(OrderType()== OP_BUY || OrderType()== OP_SELL) 
            Result = True;
  return(Result);
}
//+------------------------------------------------------------------+

bool DeleteAllPendingOrders(int& Err)
{
  int Error = ERR_NO_ERROR;
  bool Result = True;
  
  for (int i = OrdersTotal(); i > 0; i--) 
    if(OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy || OrderMagicNumber() == MN_Sell)
          if(OrderType()== OP_BUYSTOP || OrderType()== OP_SELLSTOP) 
            if(!DeleteOrder(OrderTicket(), Error))
            {
              if(Debug) Print("       #", Error);
              Result = False;
              Err = Error;
              break;
            }
  return(Result);
}
//+------------------------------------------------------------------+

bool DeleteOrder(int Ticket, int& Err)
{
  int Error;
  bool Result = False;
  
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Err = ERR_TRADE_DISABLED;
      Print("  !  \"\" .");
      break;
    }
    if(Debug) Print("  ");
    if(!IsConnected())
    {
      Err = ERR_NO_CONNECTION;
      Print("   !");
      break;
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      continue;
    }
    if(Debug) Print("  ");
    if(!OrderDelete(Ticket, CLR_NONE))
    {
      Error = GetLastError();
      if (Error == 4   || // SERVER_BUSY 
          Error == 137 || // BROKER_BUSY 
          Error == 146 || // TRADE_CONTEXT_BUSY 
          Error == 136 )  // OFF_QUOTES 
      {
        if(Debug) Print("(OrderDelete - ", Error, "): ", ErrorDescription(Error));
        if(Debug) Print(" 3 ...");
        Sleep(3000);
        continue;
      }
      else
      {
        if(Debug) Print(" (OrderDelete - ", Error, "): ", ErrorDescription(Error));
        Err = Error;
        break;
      }
    }
    else
    {
      Result = True;
      Err = ERR_NO_ERROR;
      if(Debug) Print("  #", Ticket, "  .");
      break;
    }
  }
  return(Result);  
}


bool CloseMarketOrder(int Ticket, int& Err)
{
  int Error, Slippage; bool Delay = False;
  bool Result = False; double ClosePrice;
  color Color;

  if(OrderSelect(Ticket, SELECT_BY_TICKET))
    while(!IsStopped())
    {
      if(!IsExpertEnabled())
      {
        Err = ERR_TRADE_DISABLED;
        Print("  !  \"\" .");
        break;
      }
      if(Debug) Print("  ");
      if(!IsConnected())
      {
        Err = ERR_NO_CONNECTION;
        Print("   !");
        break;
      }
      if(Debug) Print("   ");
      if(Delay || MarketInfo(Symbol(), MODE_TIME) != LastTickTime) 
      {
        if(Debug) Print(" ");
        RefreshRates();
        LastTickTime = MarketInfo(Symbol(), MODE_TIME);
        Delay = False;
      }
      else
      {
        if(Debug) Print(" ");
      }
      switch(OrderType())
      {
      case OP_BUY:
        ClosePrice = NormalizeDouble(Bid, Digits);
        Color = Blue;
        break;
      case OP_SELL:
        ClosePrice = NormalizeDouble(Ask, Digits);
        Color = Red;
        break;
      }
      Slippage = MarketInfo(Symbol(), MODE_SPREAD);
      if(IsTradeContextBusy())
      {
        if(Debug) Print("  !");
        if(Debug) Print(" 3 ...");
        Sleep(3000);
        Delay = True;
        continue;
      }
      if(Debug) Print("  ");
      if(!OrderClose(Ticket, OrderLots(), ClosePrice, Slippage, Color))
      {
        Error = GetLastError();
        if (Error == 4   || // SERVER_BUSY 
            Error == 137 || // BROKER_BUSY 
            Error == 146 || // TRADE_CONTEXT_BUSY 
            Error == 136 )  // OFF_QUOTES 
        {
          if(Debug) Print("(OrderClose - ", Error, "): ", ErrorDescription(Error));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderClose - ", Error, "): ", ErrorDescription(Error));
          Err = Error;
          break;
        }
      }
      else
      {
        Result = True;
        Err = ERR_NO_ERROR;
        if(Debug) Print("  #", Ticket, "  .");
        break;
      }
    }
  return(Result);  
}
//+------------------------------------------------------------------+

bool MarketDownEvent(int& Err)
{
  bool Result = False; 
  int Error;
  //    Buy-.
  int BuyOrders = CountOfBuy();
  if(BuyOrders == 0)
  { // Buy-     Sell-
    for(int i = 0; i < OrdersTotal(); i++ )
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Sell)) 
          if (OrderType() == OP_SELL) 
            if(CloseMarketOrder(OrderTicket(), Error))
            {
              Err = ERR_NO_ERROR;
              Result = True;
            }
            else
            {
              Result = False;
              Err = Error;
              break;
            }
  }
  int SellOrders = CountOfSell();
  if(SellOrders == 0)
  { // Sell-     Buy-
    for(int i1 = 0; i1 < OrdersTotal(); i1++ )
      if (OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
        if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Buy)) 
          if (OrderType() == OP_BUY) 
            if(CloseMarketOrder(OrderTicket(), Error))
            {
              Err = ERR_NO_ERROR;
              Result = True;
            }
            else
            {
              Result = False;
              Err = Error;
              break;
            }
  }
  return(Result);
}
//+------------------------------------------------------------------+

bool MarketUpEvent(int& Err)
{
  bool Result = False; 
  int Error;
  //    Buy-.
  int BuyOrders = CountOfBuy();
  if(BuyOrders == 0)
  { // Buy-     Sell-
    for(int i = 0; i < OrdersTotal(); i++ )
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Sell)) 
          if (OrderType() == OP_SELL) 
            if(CloseMarketOrder(OrderTicket(), Error))
            {
              Err = ERR_NO_ERROR;
              Result = True;
            }
            else
            {
              Result = False;
              Err = Error;
              break;
            }
  }
  int SellOrders = CountOfSell();
  if(SellOrders == 0)
  { // Sell-     Buy-
    for(int i1 = 0; i1 < OrdersTotal(); i1++ )
      if (OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
        if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Buy)) 
          if (OrderType() == OP_BUY) 
            if(CloseMarketOrder(OrderTicket(), Error))
            {
              Err = ERR_NO_ERROR;
              Result = True;
            }
            else
            {
              Result = False;
              Err = Error;
              break;
            }
  }
  return(Result);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| CountOfBuy()                                                     |
//+------------------------------------------------------------------+
int CountOfBuy()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Buy)) 
        if (OrderType() == OP_BUY) 
          count++;
  return(count);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| CountOfSell()                                                    |
//+------------------------------------------------------------------+
int CountOfSell()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Sell)) 
        if (OrderType() == OP_SELL) 
          count++;
  return(count);
}
//----------------------------------------------------------------------------
bool ModifyOrderAll( int tip)
{ 
  for (int i = 0; i < tip; i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol())
        if((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell)) 
      if(OrderTakeProfit()!=0 || OrderStopLoss()!=0)
      {
  while(!IsStopped())
  {
    Print(" ModifyOrder");
    if(IsTradeContextBusy())
    {
      Print("  !");
      Sleep(3000);
      continue;
    }
    Print("  ");
    if(!IsTradeAllowed())
    {
      Print("      !");
      Sleep(3000);
      continue;
    }
    Print(" ,   #",OrderTicket());
    if(!OrderModify(OrderTicket(), OrderOpenPrice(),0, 0, 0, Yellow))
    {
      Print("   ");
      int Err = GetLastError();
      break;
      Sleep(1000);
      continue;
    }
    else
    {
      Print("   ");
      break;
    }
  }
 }
  return(True);
}
//-------------------------------------------------------------

